/* CSSView.c generated by valac 0.41.91, the Vala compiler
 * generated from CSSView.vala, do not modify */

/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "granite.h"
#include <float.h>
#include <math.h>


#define TYPE_CSS_VIEW (css_view_get_type ())
#define CSS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CSS_VIEW, CSSView))
#define CSS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CSS_VIEW, CSSViewClass))
#define IS_CSS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CSS_VIEW))
#define IS_CSS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CSS_VIEW))
#define CSS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CSS_VIEW, CSSViewClass))

typedef struct _CSSView CSSView;
typedef struct _CSSViewClass CSSViewClass;
typedef struct _CSSViewPrivate CSSViewPrivate;
enum  {
	CSS_VIEW_0_PROPERTY,
	CSS_VIEW_WINDOW_PROPERTY,
	CSS_VIEW_NUM_PROPERTIES
};
static GParamSpec* css_view_properties[CSS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _CSSView {
	GtkGrid parent_instance;
	CSSViewPrivate * priv;
};

struct _CSSViewClass {
	GtkGridClass parent_class;
};

struct _CSSViewPrivate {
	GtkWindow* _window;
};

struct _Block2Data {
	int _ref_count_;
	CSSView* self;
	GtkColorButton* primary_color_button;
};


static gint CSSView_private_offset;
static gpointer css_view_parent_class = NULL;

GType css_view_get_type (void) G_GNUC_CONST;
CSSView* css_view_new (GtkWindow* window);
CSSView* css_view_construct (GType object_type,
                             GtkWindow* window);
GtkWindow* css_view_get_window (CSSView* self);
static void css_view_set_window (CSSView* self,
                          GtkWindow* value);
static GObject * css_view_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _css_view___lambda5_ (Block2Data* _data2_);
static void __css_view___lambda5__gtk_color_button_color_set (GtkColorButton* _sender,
                                                       gpointer self);
static void css_view_finalize (GObject * obj);
static void _vala_css_view_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_css_view_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);


static inline gpointer
css_view_get_instance_private (CSSView* self)
{
	return G_STRUCT_MEMBER_P (self, CSSView_private_offset);
}


CSSView*
css_view_construct (GType object_type,
                    GtkWindow* window)
{
	CSSView * self = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	self = (CSSView*) g_object_new (object_type, "halign", GTK_ALIGN_CENTER, "valign", GTK_ALIGN_CENTER, "margin", 24, "window", window, NULL);
	return self;
}


CSSView*
css_view_new (GtkWindow* window)
{
	return css_view_construct (TYPE_CSS_VIEW, window);
}


GtkWindow*
css_view_get_window (CSSView* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
css_view_set_window (CSSView* self,
                     GtkWindow* value)
{
	g_return_if_fail (self != NULL);
	if (css_view_get_window (self) != value) {
		GtkWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, css_view_properties[CSS_VIEW_WINDOW_PROPERTY]);
	}
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		CSSView* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->primary_color_button);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static void
_css_view___lambda5_ (Block2Data* _data2_)
{
	CSSView* self;
	GtkWindow* _tmp0_;
	GtkColorButton* _tmp1_;
	GdkRGBA* _tmp2_;
	GdkRGBA* _tmp3_;
	GdkRGBA _tmp4_;
	GtkCssProvider* _tmp5_;
	GtkCssProvider* _tmp6_;
	self = _data2_->self;
	_tmp0_ = self->priv->_window;
	_tmp1_ = _data2_->primary_color_button;
	g_object_get (_tmp1_, "rgba", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = *_tmp3_;
	_tmp5_ = granite_widgets_utils_set_color_primary ((GtkWidget*) _tmp0_, &_tmp4_, GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp6_);
}


static void
__css_view___lambda5__gtk_color_button_color_set (GtkColorButton* _sender,
                                                  gpointer self)
{
	_css_view___lambda5_ (self);
}


static GObject *
css_view_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CSSView * self;
	Block2Data* _data2_;
	GtkLabel* header1 = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* header2 = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkLabel* header3 = NULL;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* header4 = NULL;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkLabel* card_label = NULL;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkGrid* card = NULL;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* terminal_label = NULL;
	GtkLabel* _tmp30_;
	GtkTextView* terminal = NULL;
	GtkTextView* _tmp31_;
	GtkTextView* _tmp32_;
	GtkTextBuffer* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextView* _tmp35_;
	GtkTextView* _tmp36_;
	GtkTextView* _tmp37_;
	GtkStyleContext* _tmp38_;
	GtkLabel* back_button_label = NULL;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkButton* back_button = NULL;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkStyleContext* _tmp44_;
	GtkLabel* primary_color_label = NULL;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GdkRGBA _tmp47_ = {0};
	GtkColorButton* _tmp48_;
	GtkLabel* accent_color_label = NULL;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkImage* accent_color_icon = NULL;
	GtkImage* _tmp51_;
	GtkImage* _tmp52_;
	GtkStyleContext* _tmp53_;
	GtkLabel* accent_color_string = NULL;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkStyleContext* _tmp56_;
	GtkGrid* accent_color_grid = NULL;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkImage* _tmp60_;
	GtkGrid* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* mode_switch_label = NULL;
	GtkLabel* _tmp63_;
	GtkLabel* _tmp64_;
	GraniteModeSwitch* mode_switch = NULL;
	GraniteModeSwitch* _tmp65_;
	GraniteModeSwitch* _tmp66_;
	GraniteModeSwitch* _tmp67_;
	GraniteModeSwitch* _tmp68_;
	GtkLabel* _tmp69_;
	GtkGrid* _tmp70_;
	GtkLabel* _tmp71_;
	GtkTextView* _tmp72_;
	GtkLabel* _tmp73_;
	GtkButton* _tmp74_;
	GtkLabel* _tmp75_;
	GraniteModeSwitch* _tmp76_;
	GtkLabel* _tmp77_;
	GtkColorButton* _tmp78_;
	GtkLabel* _tmp79_;
	GtkGrid* _tmp80_;
	GtkColorButton* _tmp81_;
	parent_class = G_OBJECT_CLASS (css_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CSS_VIEW, CSSView);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = (GtkLabel*) gtk_label_new ("\"h1\" Style Class");
	g_object_ref_sink (_tmp0_);
	header1 = _tmp0_;
	_tmp1_ = header1;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 12);
	_tmp2_ = header1;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 24);
	_tmp3_ = header1;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 24);
	_tmp4_ = header1;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H1_LABEL);
	_tmp6_ = (GtkLabel*) gtk_label_new ("\"h2\" Style Class");
	g_object_ref_sink (_tmp6_);
	header2 = _tmp6_;
	_tmp7_ = header2;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, GRANITE_STYLE_CLASS_H2_LABEL);
	_tmp9_ = (GtkLabel*) gtk_label_new ("\"h3\" Style Class");
	g_object_ref_sink (_tmp9_);
	header3 = _tmp9_;
	_tmp10_ = header3;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp12_ = (GtkLabel*) gtk_label_new ("\"h4\" Style Class");
	g_object_ref_sink (_tmp12_);
	header4 = _tmp12_;
	_tmp13_ = header4;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp13_, 12);
	_tmp14_ = header4;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp16_ = (GtkLabel*) gtk_label_new ("\"card\" style class:");
	g_object_ref_sink (_tmp16_);
	card_label = _tmp16_;
	_tmp17_ = card_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_END);
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp18_);
	card = _tmp18_;
	_tmp19_ = card;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp19_, GTK_ORIENTATION_VERTICAL);
	_tmp20_ = card;
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
	gtk_style_context_add_class (_tmp21_, GRANITE_STYLE_CLASS_CARD);
	_tmp22_ = card;
	_tmp23_ = header1;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = card;
	_tmp25_ = header2;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = card;
	_tmp27_ = header3;
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = card;
	_tmp29_ = header4;
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = (GtkLabel*) gtk_label_new ("\"terminal\" style class:");
	g_object_ref_sink (_tmp30_);
	terminal_label = _tmp30_;
	_tmp31_ = (GtkTextView*) gtk_text_view_new ();
	g_object_ref_sink (_tmp31_);
	terminal = _tmp31_;
	_tmp32_ = terminal;
	_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
	_tmp34_ = _tmp33_;
	g_object_set (_tmp34_, "text", "[ 73%] Linking C executable granite-demo\n" \
"[100%] Built target granite-demo", NULL);
	_tmp35_ = terminal;
	gtk_text_view_set_pixels_below_lines (_tmp35_, 3);
	_tmp36_ = terminal;
	gtk_container_set_border_width ((GtkContainer*) _tmp36_, (guint) 12);
	_tmp37_ = terminal;
	_tmp38_ = gtk_widget_get_style_context ((GtkWidget*) _tmp37_);
	gtk_style_context_add_class (_tmp38_, GRANITE_STYLE_CLASS_TERMINAL);
	_tmp39_ = (GtkLabel*) gtk_label_new ("\"back-button\" style class:");
	g_object_ref_sink (_tmp39_);
	back_button_label = _tmp39_;
	_tmp40_ = back_button_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp40_, GTK_ALIGN_END);
	_tmp41_ = (GtkButton*) gtk_button_new_with_label ("Back Button");
	g_object_ref_sink (_tmp41_);
	back_button = _tmp41_;
	_tmp42_ = back_button;
	gtk_widget_set_halign ((GtkWidget*) _tmp42_, GTK_ALIGN_START);
	_tmp43_ = back_button;
	_tmp44_ = gtk_widget_get_style_context ((GtkWidget*) _tmp43_);
	gtk_style_context_add_class (_tmp44_, GRANITE_STYLE_CLASS_BACK_BUTTON);
	_tmp45_ = (GtkLabel*) gtk_label_new ("Set HeaderBar color:");
	g_object_ref_sink (_tmp45_);
	primary_color_label = _tmp45_;
	_tmp46_ = primary_color_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_END);
	_tmp47_.red = (gdouble) 222;
	_tmp47_.green = (gdouble) 222;
	_tmp47_.blue = (gdouble) 222;
	_tmp47_.alpha = (gdouble) 255;
	_tmp48_ = (GtkColorButton*) gtk_color_button_new_with_rgba (&_tmp47_);
	g_object_ref_sink (_tmp48_);
	_data2_->primary_color_button = _tmp48_;
	_tmp49_ = (GtkLabel*) gtk_label_new ("Accent colored labels and icons:");
	g_object_ref_sink (_tmp49_);
	accent_color_label = _tmp49_;
	_tmp50_ = accent_color_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp50_, GTK_ALIGN_END);
	_tmp51_ = (GtkImage*) gtk_image_new_from_icon_name ("emoji-body-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp51_);
	accent_color_icon = _tmp51_;
	_tmp52_ = accent_color_icon;
	_tmp53_ = gtk_widget_get_style_context ((GtkWidget*) _tmp52_);
	gtk_style_context_add_class (_tmp53_, GRANITE_STYLE_CLASS_ACCENT);
	_tmp54_ = (GtkLabel*) gtk_label_new ("Lorem ipsum dolor sit amet");
	g_object_ref_sink (_tmp54_);
	accent_color_string = _tmp54_;
	_tmp55_ = accent_color_string;
	_tmp56_ = gtk_widget_get_style_context ((GtkWidget*) _tmp55_);
	gtk_style_context_add_class (_tmp56_, GRANITE_STYLE_CLASS_ACCENT);
	_tmp57_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp57_);
	accent_color_grid = _tmp57_;
	_tmp58_ = accent_color_grid;
	gtk_grid_set_column_spacing (_tmp58_, 6);
	_tmp59_ = accent_color_grid;
	_tmp60_ = accent_color_icon;
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
	_tmp61_ = accent_color_grid;
	_tmp62_ = accent_color_string;
	gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
	_tmp63_ = (GtkLabel*) gtk_label_new ("Mode switch:");
	g_object_ref_sink (_tmp63_);
	mode_switch_label = _tmp63_;
	_tmp64_ = mode_switch_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp64_, GTK_ALIGN_END);
	_tmp65_ = granite_mode_switch_new_from_icon_name ("display-brightness-symbolic", "weather-clear-night-symbolic");
	g_object_ref_sink (_tmp65_);
	mode_switch = _tmp65_;
	_tmp66_ = mode_switch;
	granite_mode_switch_set_primary_icon_tooltip_text (_tmp66_, "Light background");
	_tmp67_ = mode_switch;
	granite_mode_switch_set_secondary_icon_tooltip_text (_tmp67_, "Dark background");
	_tmp68_ = mode_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp68_, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 24);
	_tmp69_ = card_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp69_, 0, 0, 1, 1);
	_tmp70_ = card;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp70_, 1, 0, 2, 1);
	_tmp71_ = terminal_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp71_, 0, 1, 1, 1);
	_tmp72_ = terminal;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp72_, 1, 1, 2, 1);
	_tmp73_ = back_button_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp73_, 0, 2, 1, 1);
	_tmp74_ = back_button;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp74_, 1, 2, 2, 1);
	_tmp75_ = mode_switch_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp75_, 0, 3, 1, 1);
	_tmp76_ = mode_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp76_, 1, 3, 1, 1);
	_tmp77_ = primary_color_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp77_, 0, 4, 1, 1);
	_tmp78_ = _data2_->primary_color_button;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp78_, 1, 4, 2, 1);
	_tmp79_ = accent_color_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp79_, 0, 5, 1, 1);
	_tmp80_ = accent_color_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp80_, 1, 5, 1, 1);
	_tmp81_ = _data2_->primary_color_button;
	g_signal_connect_data (_tmp81_, "color-set", (GCallback) __css_view___lambda5__gtk_color_button_color_set, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_g_object_unref0 (mode_switch);
	_g_object_unref0 (mode_switch_label);
	_g_object_unref0 (accent_color_grid);
	_g_object_unref0 (accent_color_string);
	_g_object_unref0 (accent_color_icon);
	_g_object_unref0 (accent_color_label);
	_g_object_unref0 (primary_color_label);
	_g_object_unref0 (back_button);
	_g_object_unref0 (back_button_label);
	_g_object_unref0 (terminal);
	_g_object_unref0 (terminal_label);
	_g_object_unref0 (card);
	_g_object_unref0 (card_label);
	_g_object_unref0 (header4);
	_g_object_unref0 (header3);
	_g_object_unref0 (header2);
	_g_object_unref0 (header1);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}


static void
css_view_class_init (CSSViewClass * klass)
{
	css_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CSSView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_css_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_css_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = css_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = css_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CSS_VIEW_WINDOW_PROPERTY, css_view_properties[CSS_VIEW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void
css_view_instance_init (CSSView * self)
{
	self->priv = css_view_get_instance_private (self);
}


static void
css_view_finalize (GObject * obj)
{
	CSSView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CSS_VIEW, CSSView);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (css_view_parent_class)->finalize (obj);
}


GType
css_view_get_type (void)
{
	static volatile gsize css_view_type_id__volatile = 0;
	if (g_once_init_enter (&css_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CSSViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) css_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CSSView), 0, (GInstanceInitFunc) css_view_instance_init, NULL };
		GType css_view_type_id;
		css_view_type_id = g_type_register_static (gtk_grid_get_type (), "CSSView", &g_define_type_info, 0);
		CSSView_private_offset = g_type_add_instance_private (css_view_type_id, sizeof (CSSViewPrivate));
		g_once_init_leave (&css_view_type_id__volatile, css_view_type_id);
	}
	return css_view_type_id__volatile;
}


static void
_vala_css_view_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	CSSView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CSS_VIEW, CSSView);
	switch (property_id) {
		case CSS_VIEW_WINDOW_PROPERTY:
		g_value_set_object (value, css_view_get_window (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_css_view_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	CSSView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CSS_VIEW, CSSView);
	switch (property_id) {
		case CSS_VIEW_WINDOW_PROPERTY:
		css_view_set_window (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



