/* DateTime.c generated by valac 0.41.91, the Vala compiler
 * generated from DateTime.vala, do not modify */

/*
 *  Copyright (C) 2012-2017 Granite Developers
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>
#include <gio/gio.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))



gchar* granite_date_time_get_default_time_format (gboolean is_12h,
                                                  gboolean with_second);
gchar* granite_date_time_get_relative_datetime (GDateTime* date_time);
gboolean granite_date_time_is_same_day (GDateTime* day1,
                                        GDateTime* day2);
G_GNUC_INTERNAL gboolean granite_date_time_is_clock_format_12h (void);
gchar* granite_date_time_get_default_date_format (gboolean with_weekday,
                                                  gboolean with_day,
                                                  gboolean with_year);
gchar* granite_date_time_seconds_to_time (gint seconds);


/**
     * Gets a default translated time format.
     * The function constructs a new string interpreting the //is_12h// and //with_second// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * The returned string is formatted and translated. This function is mostly used to display
     * the time in various user interfaces like the time displayed in the top panel.
     *
     * @param is_12h if the returned string should be formatted in 12h format
     * @param with_second if the returned string should include seconds
     *
     * @return the formatted and located time string.
     */
gchar*
granite_date_time_get_default_time_format (gboolean is_12h,
                                           gboolean with_second)
{
	gchar* result = NULL;
	if (is_12h == TRUE) {
		if (with_second == TRUE) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("%l:%M:%S %p"));
			result = _tmp0_;
			return result;
		} else {
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("%l:%M %p"));
			result = _tmp1_;
			return result;
		}
	} else {
		if (with_second == TRUE) {
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("%H:%M:%S"));
			result = _tmp2_;
			return result;
		} else {
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("%H:%M"));
			result = _tmp3_;
			return result;
		}
	}
}


/**
     * Compares a {@link GLib.DateTime} to {@link GLib.DateTime.now_local} and returns a location, relative date and
     * time string. Results appear as natural-language strings like "Now", "5m ago", "Yesterday"
     *
     * @param date_time a {@link GLib.DateTime} to compare against {@link GLib.DateTime.now_local}
     *
     * @return a localized, relative date and time string
     */
gchar*
granite_date_time_get_relative_datetime (GDateTime* date_time)
{
	gchar* result = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	g_return_val_if_fail (date_time != NULL, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = now;
	diff = g_date_time_difference (_tmp1_, date_time);
	_tmp2_ = now;
	if (granite_date_time_is_same_day (date_time, _tmp2_)) {
		GTimeSpan _tmp3_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp3_ = diff;
		if (_tmp3_ > ((GTimeSpan) 0)) {
			GTimeSpan _tmp4_;
			_tmp4_ = diff;
			if (_tmp4_ < G_TIME_SPAN_MINUTE) {
				gchar* _tmp5_;
				_tmp5_ = g_strdup (_ ("Now"));
				result = _tmp5_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				GTimeSpan _tmp6_;
				_tmp6_ = diff;
				if (_tmp6_ < G_TIME_SPAN_HOUR) {
					GTimeSpan minutes = 0LL;
					GTimeSpan _tmp7_;
					GTimeSpan _tmp8_;
					GTimeSpan _tmp9_;
					gchar* _tmp10_;
					_tmp7_ = diff;
					minutes = _tmp7_ / G_TIME_SPAN_MINUTE;
					_tmp8_ = minutes;
					_tmp9_ = minutes;
					_tmp10_ = g_strdup_printf (ngettext ("%dm ago", "%dm ago", (gulong) _tmp8_), (gint) _tmp9_);
					result = _tmp10_;
					_g_date_time_unref0 (now);
					return result;
				} else {
					GTimeSpan _tmp11_;
					_tmp11_ = diff;
					if (_tmp11_ < (12 * G_TIME_SPAN_HOUR)) {
						gint rounded = 0;
						GTimeSpan _tmp12_;
						gint _tmp13_;
						gint _tmp14_;
						gchar* _tmp15_;
						_tmp12_ = diff;
						rounded = (gint) round (((gdouble) _tmp12_) / G_TIME_SPAN_HOUR);
						_tmp13_ = rounded;
						_tmp14_ = rounded;
						_tmp15_ = g_strdup_printf (ngettext ("%dh ago", "%dh ago", (gulong) _tmp13_), _tmp14_);
						result = _tmp15_;
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
		} else {
			GTimeSpan _tmp16_;
			GTimeSpan _tmp17_;
			_tmp16_ = diff;
			diff = -1 * _tmp16_;
			_tmp17_ = diff;
			if (_tmp17_ < G_TIME_SPAN_HOUR) {
				GTimeSpan minutes = 0LL;
				GTimeSpan _tmp18_;
				GTimeSpan _tmp19_;
				GTimeSpan _tmp20_;
				gchar* _tmp21_;
				_tmp18_ = diff;
				minutes = _tmp18_ / G_TIME_SPAN_MINUTE;
				_tmp19_ = minutes;
				_tmp20_ = minutes;
				_tmp21_ = g_strdup_printf (ngettext ("in %dm", "in %dm", (gulong) _tmp19_), (gint) _tmp20_);
				result = _tmp21_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				GTimeSpan _tmp22_;
				_tmp22_ = diff;
				if (_tmp22_ < (12 * G_TIME_SPAN_HOUR)) {
					gint rounded = 0;
					GTimeSpan _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					gchar* _tmp26_;
					_tmp23_ = diff;
					rounded = (gint) round (((gdouble) _tmp23_) / G_TIME_SPAN_HOUR);
					_tmp24_ = rounded;
					_tmp25_ = rounded;
					_tmp26_ = g_strdup_printf (ngettext ("in %dh", "in %dh", (gulong) _tmp24_), _tmp25_);
					result = _tmp26_;
					_g_date_time_unref0 (now);
					return result;
				}
			}
		}
		_tmp27_ = granite_date_time_get_default_time_format (granite_date_time_is_clock_format_12h (), FALSE);
		_tmp28_ = _tmp27_;
		_tmp29_ = g_date_time_format (date_time, _tmp28_);
		_tmp30_ = _tmp29_;
		_g_free0 (_tmp28_);
		result = _tmp30_;
		_g_date_time_unref0 (now);
		return result;
	} else {
		GDateTime* _tmp31_;
		GDateTime* _tmp32_;
		GDateTime* _tmp33_;
		gboolean _tmp34_;
		_tmp31_ = g_date_time_add_days (date_time, 1);
		_tmp32_ = _tmp31_;
		_tmp33_ = now;
		_tmp34_ = granite_date_time_is_same_day (_tmp32_, _tmp33_);
		_g_date_time_unref0 (_tmp32_);
		if (_tmp34_) {
			gchar* _tmp35_;
			_tmp35_ = g_strdup (_ ("Yesterday"));
			result = _tmp35_;
			_g_date_time_unref0 (now);
			return result;
		} else {
			GDateTime* _tmp36_;
			GDateTime* _tmp37_;
			GDateTime* _tmp38_;
			gboolean _tmp39_;
			_tmp36_ = g_date_time_add_days (date_time, -1);
			_tmp37_ = _tmp36_;
			_tmp38_ = now;
			_tmp39_ = granite_date_time_is_same_day (_tmp37_, _tmp38_);
			_g_date_time_unref0 (_tmp37_);
			if (_tmp39_) {
				gchar* _tmp40_;
				_tmp40_ = g_strdup (_ ("Tomorrow"));
				result = _tmp40_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				gboolean _tmp41_ = FALSE;
				GTimeSpan _tmp42_;
				_tmp42_ = diff;
				if (_tmp42_ < (6 * G_TIME_SPAN_DAY)) {
					GTimeSpan _tmp43_;
					_tmp43_ = diff;
					_tmp41_ = _tmp43_ > (-6 * G_TIME_SPAN_DAY);
				} else {
					_tmp41_ = FALSE;
				}
				if (_tmp41_) {
					gchar* _tmp44_;
					gchar* _tmp45_;
					gchar* _tmp46_;
					gchar* _tmp47_;
					_tmp44_ = granite_date_time_get_default_date_format (TRUE, FALSE, FALSE);
					_tmp45_ = _tmp44_;
					_tmp46_ = g_date_time_format (date_time, _tmp45_);
					_tmp47_ = _tmp46_;
					_g_free0 (_tmp45_);
					result = _tmp47_;
					_g_date_time_unref0 (now);
					return result;
				} else {
					GDateTime* _tmp48_;
					_tmp48_ = now;
					if (g_date_time_get_year (date_time) == g_date_time_get_year (_tmp48_)) {
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
						_tmp49_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
						_tmp50_ = _tmp49_;
						_tmp51_ = g_date_time_format (date_time, _tmp50_);
						_tmp52_ = _tmp51_;
						_g_free0 (_tmp50_);
						result = _tmp52_;
						_g_date_time_unref0 (now);
						return result;
					} else {
						gchar* _tmp53_;
						_tmp53_ = g_date_time_format (date_time, "%x");
						result = _tmp53_;
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
		}
	}
	_g_date_time_unref0 (now);
}


/**
     * Gets the //clock-format// key from //org.gnome.desktop.interface// schema
     * and determines if the clock format is 12h based
     *
     * @return true if the clock format is 12h based, false otherwise.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


G_GNUC_INTERNAL gboolean
granite_date_time_is_clock_format_12h (void)
{
	gboolean result = FALSE;
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* format = NULL;
	gchar* _tmp1_;
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
	h24_settings = _tmp0_;
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
	format = _tmp1_;
	result = string_contains (format, "12h");
	_g_free0 (format);
	_g_object_unref0 (h24_settings);
	return result;
}


/**
     * Compare two {@link GLib.DateTime} and return true if they occur on the same day of the same year
     *
     * @param day1 a {@link GLib.DateTime} to compare against day2
     * @param day2 a {@link GLib.DateTime} to compare against day1
     *
     * @return true if day1 and day2 occur on the same day of the same year. False otherwise
     */
gboolean
granite_date_time_is_same_day (GDateTime* day1,
                               GDateTime* day2)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (day1 != NULL, FALSE);
	g_return_val_if_fail (day2 != NULL, FALSE);
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


/**
     * Gets the default translated date format.
     * The function constructs a new string interpreting the //with_weekday//, //with_day// and //with_year// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * As the {@link Granite.DateTime.get_default_time_format}, the returned string is formatted, translated and is also mostly used to display
     * the date in various user interfaces like the date displayed in the top panel.
     *
     * @param with_weekday if the returned string should contain the abbreviated weekday name
     * @param with_day if the returned string should contain contain the day of the month as a decimal number (range 1 to 31)
     * @param with_year if the returned string should contain the year as a decimal number including the century
     *
     * @return returns the formatted and located date string. If for some reason, the function could not determine the format to use,
     *         an empty string will be returned.
     */
gchar*
granite_date_time_get_default_date_format (gboolean with_weekday,
                                           gboolean with_day,
                                           gboolean with_year)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp24_;
	if (with_weekday == TRUE) {
		_tmp1_ = with_day == TRUE;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = with_year == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("%a, %b %e, %Y"));
		result = _tmp2_;
		return result;
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		if (with_weekday == FALSE) {
			_tmp4_ = with_day == TRUE;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			_tmp3_ = with_year == TRUE;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("%b %e %Y"));
			result = _tmp5_;
			return result;
		} else {
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			if (with_weekday == FALSE) {
				_tmp7_ = with_day == FALSE;
			} else {
				_tmp7_ = FALSE;
			}
			if (_tmp7_) {
				_tmp6_ = with_year == TRUE;
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gchar* _tmp8_;
				_tmp8_ = g_strdup (_ ("%Y"));
				result = _tmp8_;
				return result;
			} else {
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
				if (with_weekday == FALSE) {
					_tmp10_ = with_day == TRUE;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					_tmp9_ = with_year == FALSE;
				} else {
					_tmp9_ = FALSE;
				}
				if (_tmp9_) {
					gchar* _tmp11_;
					_tmp11_ = g_strdup (_ ("%b %e"));
					result = _tmp11_;
					return result;
				} else {
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					if (with_weekday == TRUE) {
						_tmp13_ = with_day == FALSE;
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						_tmp12_ = with_year == TRUE;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						gchar* _tmp14_;
						_tmp14_ = g_strdup (_ ("%a %Y"));
						result = _tmp14_;
						return result;
					} else {
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_ = FALSE;
						if (with_weekday == TRUE) {
							_tmp16_ = with_day == FALSE;
						} else {
							_tmp16_ = FALSE;
						}
						if (_tmp16_) {
							_tmp15_ = with_year == FALSE;
						} else {
							_tmp15_ = FALSE;
						}
						if (_tmp15_) {
							gchar* _tmp17_;
							_tmp17_ = g_strdup (_ ("%a"));
							result = _tmp17_;
							return result;
						} else {
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
							if (with_weekday == TRUE) {
								_tmp19_ = with_day == TRUE;
							} else {
								_tmp19_ = FALSE;
							}
							if (_tmp19_) {
								_tmp18_ = with_year == FALSE;
							} else {
								_tmp18_ = FALSE;
							}
							if (_tmp18_) {
								gchar* _tmp20_;
								_tmp20_ = g_strdup (_ ("%a, %b %e"));
								result = _tmp20_;
								return result;
							} else {
								gboolean _tmp21_ = FALSE;
								gboolean _tmp22_ = FALSE;
								if (with_weekday == FALSE) {
									_tmp22_ = with_day == FALSE;
								} else {
									_tmp22_ = FALSE;
								}
								if (_tmp22_) {
									_tmp21_ = with_year == FALSE;
								} else {
									_tmp21_ = FALSE;
								}
								if (_tmp21_) {
									gchar* _tmp23_;
									_tmp23_ = g_strdup (_ ("%b"));
									result = _tmp23_;
									return result;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp24_ = g_strdup ("");
	result = _tmp24_;
	return result;
}


/**
     * Converts seconds into the ISO 8601 standard date format for minutes (e.g. 100s to 01:40).
     * Output of negative seconds is prepended with minus character.
     *
     * @param seconds the number of seconds to convert into ISO 8601
     *
     * @return returns an ISO 8601 formatted string
     */
gchar*
granite_date_time_seconds_to_time (gint seconds)
{
	gchar* result = NULL;
	gint sign = 0;
	gint hours = 0;
	gint min = 0;
	gint sec = 0;
	gint _tmp0_;
	sign = 1;
	if (seconds < 0) {
		seconds = -seconds;
		sign = -1;
	}
	hours = seconds / 3600;
	min = (seconds % 3600) / 60;
	sec = seconds % 60;
	_tmp0_ = hours;
	if (_tmp0_ > 0) {
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		_tmp1_ = sign;
		_tmp2_ = hours;
		_tmp3_ = min;
		_tmp4_ = sec;
		_tmp5_ = g_strdup_printf ("%d:%02d:%02d", _tmp1_ * _tmp2_, _tmp3_, _tmp4_);
		result = _tmp5_;
		return result;
	} else {
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = sign;
		_tmp7_ = min;
		_tmp8_ = sec;
		_tmp9_ = g_strdup_printf ("%02d:%02d", _tmp6_ * _tmp7_, _tmp8_);
		result = _tmp9_;
		return result;
	}
}



