/* Paths.c generated by valac 0.41.91, the Vala compiler
 * generated from Paths.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Robert Dyer,
 *                          Rico Tzschichholz <ricotz@ubuntu.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define GRANITE_SERVICES_TYPE_PATHS (granite_services_paths_get_type ())
#define GRANITE_SERVICES_PATHS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_PATHS, GraniteServicesPaths))
#define GRANITE_SERVICES_PATHS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_SERVICES_TYPE_PATHS, GraniteServicesPathsClass))
#define GRANITE_SERVICES_IS_PATHS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_PATHS))
#define GRANITE_SERVICES_IS_PATHS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_SERVICES_TYPE_PATHS))
#define GRANITE_SERVICES_PATHS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_SERVICES_TYPE_PATHS, GraniteServicesPathsClass))

typedef struct _GraniteServicesPaths GraniteServicesPaths;
typedef struct _GraniteServicesPathsClass GraniteServicesPathsClass;
typedef struct _GraniteServicesPathsPrivate GraniteServicesPathsPrivate;
enum  {
	GRANITE_SERVICES_PATHS_0_PROPERTY,
	GRANITE_SERVICES_PATHS_NUM_PROPERTIES
};
static GParamSpec* granite_services_paths_properties[GRANITE_SERVICES_PATHS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GraniteServicesPaths {
	GObject parent_instance;
	GraniteServicesPathsPrivate * priv;
};

struct _GraniteServicesPathsClass {
	GObjectClass parent_class;
};


static gpointer granite_services_paths_parent_class = NULL;
static GFile* granite_services_paths__home_folder;
static GFile* granite_services_paths__home_folder = NULL;
static GFile* granite_services_paths__data_folder;
static GFile* granite_services_paths__data_folder = NULL;
static GFile* granite_services_paths__xdg_config_home_folder;
static GFile* granite_services_paths__xdg_config_home_folder = NULL;
static GFile* granite_services_paths__xdg_data_home_folder;
static GFile* granite_services_paths__xdg_data_home_folder = NULL;
static GFile* granite_services_paths__xdg_cache_home_folder;
static GFile* granite_services_paths__xdg_cache_home_folder = NULL;
static GList* granite_services_paths__xdg_data_dir_folders;
static GList* granite_services_paths__xdg_data_dir_folders = NULL;
static GFile* granite_services_paths__user_config_folder;
static GFile* granite_services_paths__user_config_folder = NULL;
static GFile* granite_services_paths__user_data_folder;
static GFile* granite_services_paths__user_data_folder = NULL;
static GFile* granite_services_paths__user_cache_folder;
static GFile* granite_services_paths__user_cache_folder = NULL;

GType granite_services_paths_get_type (void) G_GNUC_CONST;
void granite_services_paths_initialize (const gchar* app_name,
                                        const gchar* data_folder_path);
GFile* granite_services_paths_get_home_folder (void);
void granite_services_paths_set_home_folder (GFile* value);
GFile* granite_services_paths_get_data_folder (void);
void granite_services_paths_set_data_folder (GFile* value);
GFile* granite_services_paths_get_xdg_config_home_folder (void);
void granite_services_paths_set_xdg_config_home_folder (GFile* value);
GFile* granite_services_paths_get_xdg_data_home_folder (void);
void granite_services_paths_set_xdg_data_home_folder (GFile* value);
GFile* granite_services_paths_get_xdg_cache_home_folder (void);
void granite_services_paths_set_xdg_cache_home_folder (GFile* value);
GList* granite_services_paths_get_xdg_data_dir_folders (void);
void granite_services_paths_set_xdg_data_dir_folders (GList* value);
GFile* granite_services_paths_get_user_config_folder (void);
void granite_services_paths_set_user_config_folder (GFile* value);
GFile* granite_services_paths_get_user_data_folder (void);
void granite_services_paths_set_user_data_folder (GFile* value);
GFile* granite_services_paths_get_user_cache_folder (void);
void granite_services_paths_set_user_cache_folder (GFile* value);
gboolean granite_services_paths_ensure_directory_exists (GFile* dir);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GraniteServicesPaths* granite_services_paths_new (void);
GraniteServicesPaths* granite_services_paths_construct (GType object_type);
static void granite_services_paths_finalize (GObject * obj);
static void _vala_granite_services_paths_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_granite_services_paths_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
         * Initialize all the paths using the supplied app name and path to the app's data folder.
         *
         * @param app_name the name of the application
         * @param data_folder_path the path to the application's data folder
         */
static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


void
granite_services_paths_initialize (const gchar* app_name,
                                   const gchar* data_folder_path)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gchar* xdg_config_home = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* xdg_data_home = NULL;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* xdg_cache_home = NULL;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* xdg_data_dirs = NULL;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
	gboolean _tmp33_ = FALSE;
	const gchar* _tmp34_;
	gboolean _tmp51_ = FALSE;
	const gchar* _tmp52_;
	GList* dirs = NULL;
	gboolean _tmp67_ = FALSE;
	const gchar* _tmp68_;
	GList* _tmp80_;
	GList* _tmp81_;
	GList* _tmp82_;
	GList* _tmp83_;
	GFile* _tmp84_;
	GFile* _tmp85_;
	GFile* _tmp86_;
	GFile* _tmp87_;
	GFile* _tmp88_;
	GFile* _tmp89_;
	GFile* _tmp90_;
	GFile* _tmp91_;
	GFile* _tmp92_;
	GFile* _tmp93_;
	GFile* _tmp94_;
	GFile* _tmp95_;
	GFile* _tmp96_;
	GFile* _tmp97_;
	GFile* _tmp98_;
	GFile* _tmp99_;
	GFile* _tmp100_;
	GFile* _tmp101_;
	GFile* _tmp102_;
	GFile* _tmp103_;
	GFile* _tmp104_;
	GFile* _tmp105_;
	GFile* _tmp106_;
	GFile* _tmp107_;
	g_return_if_fail (app_name != NULL);
	g_return_if_fail (data_folder_path != NULL);
	_tmp0_ = granite_services_paths_get_home_folder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_get_home_dir ();
	_tmp3_ = g_file_new_for_path (_tmp2_);
	_tmp4_ = _tmp3_;
	granite_services_paths_set_home_folder (_tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = granite_services_paths_get_data_folder ();
	_tmp6_ = _tmp5_;
	_tmp7_ = g_file_new_for_path (data_folder_path);
	_tmp8_ = _tmp7_;
	granite_services_paths_set_data_folder (_tmp8_);
	_g_object_unref0 (_tmp8_);
	_tmp9_ = g_getenv ("XDG_CONFIG_HOME");
	_tmp10_ = g_strdup (_tmp9_);
	xdg_config_home = _tmp10_;
	_tmp11_ = g_getenv ("XDG_DATA_HOME");
	_tmp12_ = g_strdup (_tmp11_);
	xdg_data_home = _tmp12_;
	_tmp13_ = g_getenv ("XDG_CACHE_HOME");
	_tmp14_ = g_strdup (_tmp13_);
	xdg_cache_home = _tmp14_;
	_tmp15_ = g_getenv ("XDG_DATA_DIRS");
	_tmp16_ = g_strdup (_tmp15_);
	xdg_data_dirs = _tmp16_;
	_tmp18_ = xdg_config_home;
	if (_tmp18_ == NULL) {
		_tmp17_ = TRUE;
	} else {
		const gchar* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp19_ = xdg_config_home;
		_tmp20_ = strlen (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp17_ = _tmp21_ == 0;
	}
	if (_tmp17_) {
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		_tmp22_ = granite_services_paths_get_xdg_config_home_folder ();
		_tmp23_ = _tmp22_;
		_tmp24_ = granite_services_paths_get_home_folder ();
		_tmp25_ = _tmp24_;
		_tmp26_ = g_file_get_child (_tmp25_, ".config");
		_tmp27_ = _tmp26_;
		granite_services_paths_set_xdg_config_home_folder (_tmp27_);
		_g_object_unref0 (_tmp27_);
	} else {
		GFile* _tmp28_;
		GFile* _tmp29_;
		const gchar* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		_tmp28_ = granite_services_paths_get_xdg_config_home_folder ();
		_tmp29_ = _tmp28_;
		_tmp30_ = xdg_config_home;
		_tmp31_ = g_file_new_for_path (_tmp30_);
		_tmp32_ = _tmp31_;
		granite_services_paths_set_xdg_config_home_folder (_tmp32_);
		_g_object_unref0 (_tmp32_);
	}
	_tmp34_ = xdg_data_home;
	if (_tmp34_ == NULL) {
		_tmp33_ = TRUE;
	} else {
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		_tmp35_ = xdg_data_home;
		_tmp36_ = strlen (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp33_ = _tmp37_ == 0;
	}
	if (_tmp33_) {
		GFile* _tmp38_;
		GFile* _tmp39_;
		GFile* _tmp40_;
		GFile* _tmp41_;
		GFile* _tmp42_;
		GFile* _tmp43_;
		GFile* _tmp44_;
		GFile* _tmp45_;
		_tmp38_ = granite_services_paths_get_xdg_data_home_folder ();
		_tmp39_ = _tmp38_;
		_tmp40_ = granite_services_paths_get_home_folder ();
		_tmp41_ = _tmp40_;
		_tmp42_ = g_file_get_child (_tmp41_, ".local");
		_tmp43_ = _tmp42_;
		_tmp44_ = g_file_get_child (_tmp43_, "share");
		_tmp45_ = _tmp44_;
		granite_services_paths_set_xdg_data_home_folder (_tmp45_);
		_g_object_unref0 (_tmp45_);
		_g_object_unref0 (_tmp43_);
	} else {
		GFile* _tmp46_;
		GFile* _tmp47_;
		const gchar* _tmp48_;
		GFile* _tmp49_;
		GFile* _tmp50_;
		_tmp46_ = granite_services_paths_get_xdg_data_home_folder ();
		_tmp47_ = _tmp46_;
		_tmp48_ = xdg_data_home;
		_tmp49_ = g_file_new_for_path (_tmp48_);
		_tmp50_ = _tmp49_;
		granite_services_paths_set_xdg_data_home_folder (_tmp50_);
		_g_object_unref0 (_tmp50_);
	}
	_tmp52_ = xdg_cache_home;
	if (_tmp52_ == NULL) {
		_tmp51_ = TRUE;
	} else {
		const gchar* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		_tmp53_ = xdg_cache_home;
		_tmp54_ = strlen (_tmp53_);
		_tmp55_ = _tmp54_;
		_tmp51_ = _tmp55_ == 0;
	}
	if (_tmp51_) {
		GFile* _tmp56_;
		GFile* _tmp57_;
		GFile* _tmp58_;
		GFile* _tmp59_;
		GFile* _tmp60_;
		GFile* _tmp61_;
		_tmp56_ = granite_services_paths_get_xdg_cache_home_folder ();
		_tmp57_ = _tmp56_;
		_tmp58_ = granite_services_paths_get_home_folder ();
		_tmp59_ = _tmp58_;
		_tmp60_ = g_file_get_child (_tmp59_, ".cache");
		_tmp61_ = _tmp60_;
		granite_services_paths_set_xdg_cache_home_folder (_tmp61_);
		_g_object_unref0 (_tmp61_);
	} else {
		GFile* _tmp62_;
		GFile* _tmp63_;
		const gchar* _tmp64_;
		GFile* _tmp65_;
		GFile* _tmp66_;
		_tmp62_ = granite_services_paths_get_xdg_cache_home_folder ();
		_tmp63_ = _tmp62_;
		_tmp64_ = xdg_cache_home;
		_tmp65_ = g_file_new_for_path (_tmp64_);
		_tmp66_ = _tmp65_;
		granite_services_paths_set_xdg_cache_home_folder (_tmp66_);
		_g_object_unref0 (_tmp66_);
	}
	dirs = NULL;
	_tmp68_ = xdg_data_dirs;
	if (_tmp68_ == NULL) {
		_tmp67_ = TRUE;
	} else {
		const gchar* _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		_tmp69_ = xdg_data_dirs;
		_tmp70_ = strlen (_tmp69_);
		_tmp71_ = _tmp70_;
		_tmp67_ = _tmp71_ == 0;
	}
	if (_tmp67_) {
		GFile* _tmp72_;
		GFile* _tmp73_;
		_tmp72_ = g_file_new_for_path ("/usr/local/share");
		dirs = g_list_append (dirs, _tmp72_);
		_tmp73_ = g_file_new_for_path ("/usr/share");
		dirs = g_list_append (dirs, _tmp73_);
	} else {
		const gchar* _tmp74_;
		gchar** _tmp75_;
		gchar** _tmp76_;
		_tmp74_ = xdg_data_dirs;
		_tmp76_ = _tmp75_ = g_strsplit (_tmp74_, ":", 0);
		{
			gchar** path_collection = NULL;
			gint path_collection_length1 = 0;
			gint _path_collection_size_ = 0;
			gint path_it = 0;
			path_collection = _tmp76_;
			path_collection_length1 = _vala_array_length (_tmp75_);
			for (path_it = 0; path_it < _vala_array_length (_tmp75_); path_it = path_it + 1) {
				gchar* _tmp77_;
				gchar* path = NULL;
				_tmp77_ = g_strdup (path_collection[path_it]);
				path = _tmp77_;
				{
					const gchar* _tmp78_;
					GFile* _tmp79_;
					_tmp78_ = path;
					_tmp79_ = g_file_new_for_path (_tmp78_);
					dirs = g_list_append (dirs, _tmp79_);
					_g_free0 (path);
				}
			}
			path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	_tmp80_ = granite_services_paths_get_xdg_data_dir_folders ();
	_tmp81_ = _tmp80_;
	_tmp82_ = dirs;
	_tmp83_ = g_list_copy (_tmp82_);
	granite_services_paths_set_xdg_data_dir_folders (_tmp83_);
	_tmp84_ = granite_services_paths_get_user_config_folder ();
	_tmp85_ = _tmp84_;
	_tmp86_ = granite_services_paths_get_xdg_config_home_folder ();
	_tmp87_ = _tmp86_;
	_tmp88_ = g_file_get_child (_tmp87_, app_name);
	_tmp89_ = _tmp88_;
	granite_services_paths_set_user_config_folder (_tmp89_);
	_g_object_unref0 (_tmp89_);
	_tmp90_ = granite_services_paths_get_user_data_folder ();
	_tmp91_ = _tmp90_;
	_tmp92_ = granite_services_paths_get_xdg_data_home_folder ();
	_tmp93_ = _tmp92_;
	_tmp94_ = g_file_get_child (_tmp93_, app_name);
	_tmp95_ = _tmp94_;
	granite_services_paths_set_user_data_folder (_tmp95_);
	_g_object_unref0 (_tmp95_);
	_tmp96_ = granite_services_paths_get_user_cache_folder ();
	_tmp97_ = _tmp96_;
	_tmp98_ = granite_services_paths_get_xdg_cache_home_folder ();
	_tmp99_ = _tmp98_;
	_tmp100_ = g_file_get_child (_tmp99_, app_name);
	_tmp101_ = _tmp100_;
	granite_services_paths_set_user_cache_folder (_tmp101_);
	_g_object_unref0 (_tmp101_);
	_tmp102_ = granite_services_paths_get_user_config_folder ();
	_tmp103_ = _tmp102_;
	granite_services_paths_ensure_directory_exists (_tmp103_);
	_tmp104_ = granite_services_paths_get_user_data_folder ();
	_tmp105_ = _tmp104_;
	granite_services_paths_ensure_directory_exists (_tmp105_);
	_tmp106_ = granite_services_paths_get_user_cache_folder ();
	_tmp107_ = _tmp106_;
	granite_services_paths_ensure_directory_exists (_tmp107_);
	(dirs == NULL) ? NULL : (dirs = (_g_list_free__g_object_unref0_ (dirs), NULL));
	_g_free0 (xdg_data_dirs);
	_g_free0 (xdg_cache_home);
	_g_free0 (xdg_data_home);
	_g_free0 (xdg_config_home);
}


/**
         * Ensure the directory exists, by creating it if it does not.
         *
         * @param dir the directory in question
         *
         * @return `true` is the directory exists, `false` if it does not
         */
gboolean
granite_services_paths_ensure_directory_exists (GFile* dir)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (dir != NULL, FALSE);
	if (!g_file_query_exists (dir, NULL)) {
		gboolean _tmp2_ = FALSE;
		{
			g_file_make_directory_with_parents (dir, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch4_g_error;
			}
			result = TRUE;
			return result;
		}
		goto __finally4;
		__catch4_g_error:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			g_clear_error (&_inner_error_);
			_inner_error_ = NULL;
			_tmp0_ = g_file_get_path (dir);
			_tmp1_ = _tmp0_;
			g_error ("Paths.vala:145: Could not access or create the directory '%s'.", _tmp1_);
			_g_free0 (_tmp1_);
		}
		__finally4:
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp2_;
	}
	result = FALSE;
	return result;
}


GraniteServicesPaths*
granite_services_paths_construct (GType object_type)
{
	GraniteServicesPaths * self = NULL;
	self = (GraniteServicesPaths*) g_object_new (object_type, NULL);
	return self;
}


GraniteServicesPaths*
granite_services_paths_new (void)
{
	return granite_services_paths_construct (GRANITE_SERVICES_TYPE_PATHS);
}


GFile*
granite_services_paths_get_home_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__home_folder;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
granite_services_paths_set_home_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__home_folder);
	granite_services_paths__home_folder = _tmp0_;
}


GFile*
granite_services_paths_get_data_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__data_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_data_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__data_folder);
	granite_services_paths__data_folder = _tmp0_;
}


GFile*
granite_services_paths_get_xdg_config_home_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__xdg_config_home_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_xdg_config_home_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__xdg_config_home_folder);
	granite_services_paths__xdg_config_home_folder = _tmp0_;
}


GFile*
granite_services_paths_get_xdg_data_home_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__xdg_data_home_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_xdg_data_home_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__xdg_data_home_folder);
	granite_services_paths__xdg_data_home_folder = _tmp0_;
}


GFile*
granite_services_paths_get_xdg_cache_home_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__xdg_cache_home_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_xdg_cache_home_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__xdg_cache_home_folder);
	granite_services_paths__xdg_cache_home_folder = _tmp0_;
}


GList*
granite_services_paths_get_xdg_data_dir_folders (void)
{
	GList* result;
	GList* _tmp0_;
	_tmp0_ = granite_services_paths__xdg_data_dir_folders;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_xdg_data_dir_folders (GList* value)
{
	GList* _tmp0_;
	_tmp0_ = value;
	value = NULL;
	(granite_services_paths__xdg_data_dir_folders == NULL) ? NULL : (granite_services_paths__xdg_data_dir_folders = (_g_list_free__g_object_unref0_ (granite_services_paths__xdg_data_dir_folders), NULL));
	granite_services_paths__xdg_data_dir_folders = _tmp0_;
	(value == NULL) ? NULL : (value = (_g_list_free__g_object_unref0_ (value), NULL));
}


GFile*
granite_services_paths_get_user_config_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__user_config_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_user_config_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__user_config_folder);
	granite_services_paths__user_config_folder = _tmp0_;
}


GFile*
granite_services_paths_get_user_data_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__user_data_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_user_data_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__user_data_folder);
	granite_services_paths__user_data_folder = _tmp0_;
}


GFile*
granite_services_paths_get_user_cache_folder (void)
{
	GFile* result;
	GFile* _tmp0_;
	_tmp0_ = granite_services_paths__user_cache_folder;
	result = _tmp0_;
	return result;
}


void
granite_services_paths_set_user_cache_folder (GFile* value)
{
	GFile* _tmp0_;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (granite_services_paths__user_cache_folder);
	granite_services_paths__user_cache_folder = _tmp0_;
}


static void
granite_services_paths_class_init (GraniteServicesPathsClass * klass)
{
	granite_services_paths_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_services_paths_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_services_paths_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_services_paths_finalize;
}


static void
granite_services_paths_instance_init (GraniteServicesPaths * self)
{
}


static void
granite_services_paths_finalize (GObject * obj)
{
	GraniteServicesPaths * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_PATHS, GraniteServicesPaths);
	G_OBJECT_CLASS (granite_services_paths_parent_class)->finalize (obj);
}


/**
     * A class for interacting with frequently-used directories, following the
     * XDG Base Directory specification: [[http://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html]]
     */
GType
granite_services_paths_get_type (void)
{
	static volatile gsize granite_services_paths_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_paths_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesPathsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_paths_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesPaths), 0, (GInstanceInitFunc) granite_services_paths_instance_init, NULL };
		GType granite_services_paths_type_id;
		granite_services_paths_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesPaths", &g_define_type_info, 0);
		g_once_init_leave (&granite_services_paths_type_id__volatile, granite_services_paths_type_id);
	}
	return granite_services_paths_type_id__volatile;
}


static void
_vala_granite_services_paths_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GraniteServicesPaths * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_PATHS, GraniteServicesPaths);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_granite_services_paths_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GraniteServicesPaths * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_PATHS, GraniteServicesPaths);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



